`timescale 1ns/1ns

module adc_testbench();
	
	reg clk, reset;
	
	wire convst, sck, mosi;
	reg miso;
	wire [47:0] data_out;
	wire data_val;
	reg data_rdy;
	

	//Initialize clocks and index
	initial begin
		clk = 1'b0;
	end
	
	//Toggle the clocks
	always begin
		#10
		clk  = !clk;
	end
	
	initial begin
		#50
		#1600
		miso = 1'b0;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#40
		miso = 1'b0;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#80
		#1600
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#40
		miso = 1'b0;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b1;
		#40
		miso = 1'b0;
		#40
		miso = 1'b0;
	end

	//Intialize and drive signals
	initial begin
		reset  = 1'b0;
		#10 
		reset  = 1'b1;
		#30
		reset  = 1'b0;
		#10000
		$stop;
    	end
	
	initial begin
		data_rdy = 1'b0;
		#4250
		data_rdy = 1'b1;
		#60
		data_rdy = 1'b0;
		#100
		data_rdy = 1'b1;
	end

adc dut(
	.clk(clk),
	.reset(reset),
	
	.convst(convst),
	.sck(sck),
	.mosi(mosi),
	.miso(miso),
	
	.data_out(data_out),
	.data_val(data_val),
	.data_rdy(data_rdy)
);


endmodule
