module cfg_reg #(
    parameter width = 24,
    parameter id = 0,
    parameter reset_value = 0
)(
    input  wire clk,
    input  wire reset,
    input  wire [31:0] cfg,
    output reg  [width-1:0] out
);

wire [7:0] cfg_id;
assign cfg_id = cfg[31:24];
wire [width-1:0] cfg_val;
assign cfg_val = cfg[width-1:0];

initial begin
	out <= reset_value;
end

always @(posedge clk) begin
    if (reset) begin
        out <= reset_value;
    end else begin
        if (cfg_id == id) begin
            out <= cfg_val;
        end else begin
            out <= out;
        end
    end
end

endmodule