`timescale 1ns/1ns

module testbench();
	
	reg clk_50, clk_25, reset;
		
	//Initialize clocks and index
	initial begin
		clk_50 = 1'b0;
		clk_25 = 1'b0;
	end
	
	//Toggle the clocks
	always begin
		#10
		clk_50  = !clk_50;
	end
		
	//Intialize and drive signals
	initial begin
		reset  = 1'b0;
		#10 
		reset  = 1'b1;
		#30
		reset  = 1'b0;
		#10000
		$stop();
	end
	
	wire adc_read, adc_write;
	wire adc_waitrequest;
	reg [2:0] request_timer;
	assign adc_waitrequest = request_timer != 0;
	always @(posedge clk_50) begin
		if (reset) begin
			request_timer <= 0;
		end else if (adc_write) begin
			request_timer <= 3'd5;
		end else if (request_timer > 0) begin
			request_timer <= request_timer - 1;
		end
	end

	//Instantiation of Device Under Test
	adc_writer DUT   (
				.clk(clk_50), 
				.reset(reset),
				
				.adc_readdata(32'd27),
				.adc_writedata(),
				.adc_address(),
				
				.adc_read(adc_read),
				.adc_write(adc_write),
				.adc_waitrequest(adc_waitrequest),
				
				.vga_write(),
				.vga_address(),
				.vga_writedata()
	);
	
endmodule

