`timescale 1ns/1ns

module trigger_testbench();
	
	reg clk, reset;

	//Initialize clocks and index
	initial begin
		clk = 1'b0;
	end
	
	//Toggle the clocks
	always begin
		#10
		clk  = !clk;
	end
	
	//Intialize and drive signals
	initial begin
		reset  = 1'b0;
		#10 
		reset  = 1'b1;
		#30
		reset  = 1'b0;
		#100000
		$stop;
    	end

wire adc_rdy;
reg [11:0] adc_data;
always @(posedge clk) begin
	if (reset) begin
		adc_data <= 12'b0;
	end else if (adc_rdy) begin
		adc_data <= adc_data + 12'b1;
	end
end

wire buf_write;

trigger dut(
	.clk(clk),
	.reset(reset),
	
	.adc_val(1'b1),
	.adc_rdy(adc_rdy),
	.adc_data(adc_data),

	.buf_writedata(),
	.buf_address(),
	.buf_write(buf_write),
	.buf_ack(buf_write),

	.refresh_rdy(1'b1),
	.refresh_val()

);

endmodule
